<template>
    <div class="container-sm">
        <h1 class="mt-5 mb-4 pb-2 text-uppercase text-center">Levantamento de preços</h1>

        <div class="form-group mb-4">
            <label for="municipio">Município</label>
            <select id="municipio"
                    class="form-control"
                    name="municipio"
                    v-model="municipio"
                    v-bind:class="{ 'is-invalid': this.submitted && !isMunicipioValid() }"
                    v-on:change="municipioChanged">
                <option v-if="!municipios" value="null" disabled hidden>
                    Carregando municípios...
                </option>
                <template v-if="municipios !== null">
                    <option v-if="municipios.length === 0" value="null" disabled hidden>
                        Nenhum município disponível
                    </option>
                    <option v-if="municipios.length !== 0" value="null" disabled hidden>
                        Selecione um município
                    </option>
                    <option v-for="municipio in municipios" v-bind:value="municipio">
                        {{ municipio.nome }}
                    </option>
                </template>
            </select>
            <div class="invalid-feedback">
                É preciso selecionar um município.
            </div>
        </div>

        <div class="form-group mb-4">
            <label for="produto">Produto</label>
            <select id="produto"
                    class="form-control"
                    name="produto"
                    v-model="produto"
                    v-bind:class="{ 'is-invalid': this.submitted && !isProdutoValid() }">
                <option v-if="!municipio" value="null" disabled hidden>
                    Primeiro, selecione um município
                </option>
                <template v-if="municipio">
                    <option v-if="!produtosLevantamento[municipio.id]" value="null" disabled hidden>
                        Carregando produtos...
                    </option>
                    <option v-if="produtosLevantamento[municipio.id] && produtosLevantamento[municipio.id].length !== 0"
                            value="null" disabled hidden>
                        Selecione um produto
                    </option>
                    <option v-if="produtosLevantamento[municipio.id] && produtosLevantamento[municipio.id].length === 0"
                            value="null" disabled hidden>
                        Nenhum produto disponível
                    </option>
                    <option v-for="produto in produtosLevantamento[municipio.id]" v-bind:value="produto">
                        {{ produto.nome }}
                    </option>
                </template>
            </select>
            <div class="invalid-feedback">
                É preciso selecionar um produto.
            </div>
        </div>

        <div class="form-group mb-4">
            <label for="produtor">Produtor</label>
            <select id="produtor"
                    class="form-control"
                    name="produtor"
                    v-model="produtor"
                    v-bind:class="{ 'is-invalid': this.submitted && !isProdutorValid() }">
                <option v-if="!municipio" value="null" disabled hidden>
                    Primeiro, selecione um município
                </option>
                <template v-if="municipio">
                    <option v-if="!produtores[municipio.id]" value="null" disabled hidden>
                        Carregando produtores...
                    </option>
                    <option v-if="produtores[municipio.id] && produtores[municipio.id].length !== 0"
                            value="null" disabled hidden>
                        Selecione um produtor
                    </option>
                    <option v-if="produtores[municipio.id] && produtores[municipio.id].length === 0"
                            value="null" disabled hidden>
                        Nenhum produtor disponível
                    </option>

                    <option v-for="produtor in produtores[municipio.id]" v-bind:value="produtor">
                        {{ produtor.nome }}
                    </option>
                </template>
            </select>
            <div class="invalid-feedback">
                É preciso selecionar um produtor.
            </div>
        </div>

        <div class="form-group mb-4">
            <label for="preco">Preço</label>
            <money id="preco" class="form-control" v-model="preco" v-bind="money"
                   v-bind:class="{ 'is-invalid': this.submitted && !isPrecoValid() }"></money>
            <div class="invalid-feedback"
                 v-if="produto">
                O preço deve estar entre R$ {{ produto.preco_minimo.toFixed(2) }} e R$ {{ produto.preco_maximo.toFixed(2) }}.
            </div>
        </div>

        <button type="button" class="btn btn-dark btn-md mt-4 d-block mx-auto" v-on:click="salvar">
            Salvar
        </button>
    </div>
</template>

<script>
    import {Money} from 'v-money'
    import {mapState} from 'vuex'

    export default {
        computed: mapState([
            'user',
            'municipios',
            'produtores',
            'produtosLevantamento'
        ]),
        data() {
            return {
                submitted: false,
                municipio: null,
                produto: null,
                produtor: null,
                preco: 0,
                money: {
                    decimal: ',',
                    thousands: '',
                    prefix: 'R$ ',
                    precision: 2,
                    masked: false
                },
            }
        },
        methods: {
            municipioChanged() {
                this.produto = null
                this.produtor = null

                this.$store.dispatch('getProdutores', this.municipio)
                this.$store.dispatch('getProdutosLevantamento', this.municipio)
            },
            isPrecoValid() {
                return this.produto && (this.preco >= this.produto.preco_minimo && this.preco <= this.produto.preco_maximo)
            },
            isMunicipioValid() {
                return this.municipio
            },
            isProdutoValid() {
                return this.produto
            },
            isProdutorValid() {
                return this.produtor
            },
            salvar() {
                this.submitted = true

                if (!this.isPrecoValid() || !this.isMunicipioValid() || !this.isProdutoValid() || !this.isProdutorValid()) {
                    return
                }

                this.$http.post('levantamento', {
                    municipio: this.municipio.id,
                    produto: this.produto.id,
                    produtor: this.produtor.id,
                    preco: this.preco * 100,
                    autor: this.user.name,
                })
                    .then(response => response.json())
                    .then(data => {
                        this.submitted = false
                        this.municipio = null
                        this.produto = null
                        this.produtor = null
                        this.preco = 0
                    })
                    .catch(error => {
                        console.error('Falha ao enviar levantamento: ' + error)
                    })
            },
        },
        components: {
            Money,
        },
    }
</script>
